var fs = require('fs');
var bowerJson = require('bower-json');
exports.read = read;
exports.write = write;

function read(filename) {
  return function(done) { bowerJson.read(filename, done); };
}

function write(filename, content) {
  return function(done) { fs.writeFile(filename, content, done); };
}